
float mag,sx,sy,ox,oy;
int[] amp2trinary4_pos;
int[] amp2trinary4_neg;
int vpwr;

int[] halfsine;
int oldtrisum,bitsum;

int[] chan = new int[5];

void setup()
  {
    int t1,t2,t3,t4,i,k,m;
    float t,u;
  amp2trinary4_pos = new int[41];
  amp2trinary4_neg = new int[41];
  halfsine = new int[401];
  for(i=0,t=0.0; i <= 200; i++,t += PI/200.0)
    {
      u = sin(t) * 40.0;
      halfsine[i] = (int)(u + 0.5);
    }
  oldtrisum=0;
  bitsum=0;
  size(1000,640); 
  mag = 1.0;
  sx = 900.0;
  sy = 300.0;
  ox = 50.0;
  oy = 325.0;
  
  amp2trinary4_pos[0] = 0; 
  amp2trinary4_neg[0] = 0; 
  t2=t3=t4=0;
  t1 = 1;
  for(i=1; i <= 40; i++)
    {
    k = 0;  
    m = 0;
    if (t1 ==  1) k += 0x01;
    if (t1 == -1) k += 0x02;
    if (t2 ==  1) k += 0x04;
    if (t2 == -1) k += 0x08;
    if (t3 ==  1) k += 0x10;
    if (t3 == -1) k += 0x20;
    if (t4 ==  1) k += 0x40;
    if (t4 == -1) k += 0x80;

    if (t1 == -1) m += 0x01;
    if (t1 ==  1) m += 0x02;
    if (t2 == -1) m += 0x04;
    if (t2 ==  1) m += 0x08;
    if (t3 == -1) m += 0x10;
    if (t3 ==  1) m += 0x20;
    if (t4 == -1) m += 0x40;
    if (t4 ==  1) m += 0x80;
    amp2trinary4_pos[i] = k; 
    amp2trinary4_neg[i] = m; 
    t1++; 
    if (t1 > 1) 
      {
        t1 = -1;
        t2++;
        if (t2 > 1)
          {
            t2 = -1;
            t3++; 
            if (t3 > 1)
              {
                t3 = -1;
                t4++;
              }
          }      
      }   
    }
  }

int tribit(int i,int spflag)
  {
  int v;
  int b,j,k;
  v = (halfsine[i] * vpwr + 128) >> 8;
  if (spflag == 0)
      b = amp2trinary4_pos[v];
  else
      b = amp2trinary4_neg[v];
  return b;
  }
  
  
int trisum(int i,int spflag)
  {
  int v;
  int b,j,k;
  v = (halfsine[i] * vpwr + 128) >> 8;
  if (spflag == 0)
      b = amp2trinary4_pos[v];
  else
      b = amp2trinary4_neg[v];
  v = 0;
  if ((b & 0x80) > 0) v += 27;
  if ((b & 0x40) > 0) v -= 27; 
  if ((b & 0x20) > 0) v += 9;
  if ((b & 0x10) > 0) v -= 9; 
  if ((b & 0x08) > 0) v += 3;
  if ((b & 0x04) > 0) v -= 3;  
  if ((b & 0x02) > 0) v += 1;
  if ((b & 0x01) > 0) v -= 1;  
  
  chan[0]=chan[1]=chan[2] =chan[3] = 0;
  if ((b & 0x80) > 0) chan[0] = 27;
  if ((b & 0x40) > 0) chan[0] = -27; 
  if ((b & 0x20) > 0) chan[1] =  9;
  if ((b & 0x10) > 0) chan[1] = -9; 
  if ((b & 0x08) > 0) chan[2] =  3;
  if ((b & 0x04) > 0) chan[2] = -3;  
  if ((b & 0x02) > 0) chan[3] =  1;
  if ((b & 0x01) > 0) chan[3] = -1;  
  
  
  k = b ^ oldtrisum;
  j=0;
  if ((k & 0x80) > 0) j++;
  if ((k & 0x40) > 0) j++; 
  if ((k & 0x20) > 0) j++;
  if ((k & 0x10) > 0) j++; 
  if ((k & 0x08) > 0) j++;
  if ((k & 0x04) > 0) j++;  
  if ((k & 0x02) > 0) j++;
  if ((k & 0x01) > 0) j++;  
  oldtrisum = b;
  bitsum += j;
  return v;
  }
  
  
void draw()
  {
   background(128); 
   slider(); 
   float t,oldx,oldy,nux,nuy;
   int i,j,k,n;
   bitsum=0;

   oldx = 0.0;
   oldy = 0.0;
   stroke(0);
   line(ox,oy,sx+ox,oy);
   for (t=0.0; t < PI*2.0; t += 0.01)
     {
       nux = t/(PI*2.0);
       nuy = sin(t)*mag;
       line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
       oldx = nux;
       oldy = nuy;
     }
     
   stroke(120,255,120);  
   oldx = 0.0;
   oldy = 0.0;
   vpwr = (int)(mag * 255.0 + 0.5);
   for(i=0; i < 200; i++)
     {
      j = trisum(i,1);       
      nux = 0.5*(float)i/200.0;
      nuy = (float)j/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }
   for(i=0; i < 200; i++)
     {
      j = trisum(i,0);       
      nux = 0.5 + 0.5*(float)i/200.0;
      nuy = (float)j/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     } 
     
   stroke(255,120,120);
    oldx = 0.0;
   oldy = 0.0;
   for(i=0; i < 200; i++)
     {
      j = trisum(i,1);       
      nux = 0.5*(float)i/200.0;
      nuy = (float)chan[0]/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }
   for(i=0; i < 200; i++)
     {
      j = trisum(i,0);       
      nux = 0.5 + 0.5*(float)i/200.0;
      nuy = (float)chan[0]/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }   
  
   stroke(255,120,255);
    oldx = 0.0;
   oldy = 0.0;
   for(i=0; i < 200; i++)
     {
      j = trisum(i,1);       
      nux = 0.5*(float)i/200.0;
      nuy = (float)chan[1]/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }
   for(i=0; i < 200; i++)
     {
      j = trisum(i,0);       
      nux = 0.5 + 0.5*(float)i/200.0;
      nuy = (float)chan[1]/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }   
       
     stroke(255,255,0);
      oldx = 0.0;
   oldy = 0.0;
   for(i=0; i < 200; i++)
     {
      j = trisum(i,1);       
      nux = 0.5*(float)i/200.0;
      nuy = (float)chan[2]/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }
   for(i=0; i < 200; i++)
     {
      j = trisum(i,0);       
      nux = 0.5 + 0.5*(float)i/200.0;
      nuy = (float)chan[2]/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }   
       
   stroke(0,0,255);    
   for(i=0; i < 200; i++)
     {
      j = trisum(i,1);       
      nux = 0.5*(float)i/200.0;
      nuy = (float)chan[3]/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }
   for(i=0; i < 200; i++)
     {
      j = trisum(i,0);       
      nux = 0.5 + 0.5*(float)i/200.0;
      nuy = (float)chan[3]/40.0;
      line(oldx*sx+ox,oldy*sy+oy,nux*sx+ox,nuy*sy+oy);
      oldx = nux;
      oldy = nuy;       
     }   
       
      
     
  textSize(10);
  //text("mag = " + mag + ", bit changes = " + bitsum,60,300);
  t = (mouseX - ox)/sx;
  if (t < 0.0) t = 0.0;
  if (t > 1.0) t = 1.0;
  k = int(0.5 + t * 400.0);
  if (k > 200)
    k = tribit(k-200,0);
  else
    k = tribit(k,1);
  text("k = " + binary(k),60,100);
  
  }

void mouseDragged()
  {
    if (mouseX > 5 && mouseX < 45)
      {
        mag = (mouseY-10.0)/600.0; 
        if (mag < 0.0) mag = 0.0;
        if (mag > 1.0) mag = 1.0;
      }
  }
  
void keyPressed() 
{
int c;
c = keyCode;
if (c == 40)  mag += 0.002;
if (c == 38)  mag -= 0.002;  
if (mag < 0.0) mag = 0.0;
if (mag > 1.0) mag = 1.0;
}
  
  
void slider()
  {
    float v;
   fill(255); 
   rect(5,5,45,600);
   fill(0);
   v = 5 + 600.0 * mag;
   rect(5,v,45,10);
  }
